#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#define SIZE 1000

int countvowels(char *) ;
int vowelcompare(const void * str1, const void * str2 );
char ** cleartext(char *textin, int *words) ;
char * gettext(char *fname);
void writetext(char **pruned, int words, char *fname);

int main () {
    char *textin ;
    char **pruned ;
    int words = 0, i;

    textin = gettext("infileTh2.txt");      /* read text from file */
    pruned = cleartext( textin, &words);    /* clear symbols and construct array of pointers to strings */
    qsort(pruned, words, sizeof(char *), vowelcompare); /* sort array of pointers to strings
                                                         * according to rule vowelcompare */
    for (i=0;i<words;i++) { /* print loop not really required */
        printf("%s %d\n", pruned[i], countvowels(pruned[i]));   }

    writetext(pruned, words, "outfile.txt");

    free(textin);
    free(pruned);
    return 0;
}

int countvowels(char * str) {
    int count=0,i;
    for (i=0;str[i]!=0; i++)
       if (strchr("aeoiu",tolower(str[i]))!=NULL) count ++;
       /* y is not always a vowel, yet it is always omitted here, could add a case*/
    return count;
}

/* rule for sorting an array of pointers to strings in ascending order of number of vowels contained in strings*/
int vowelcompare(const void * str1, const void * str2 ) {
    return  countvowels( *  (char **) str1) - countvowels( *  (char **) str2);
}

/*create pruned as an array of pointers to strings derived by splitting textin using strtok*/
char ** cleartext( char *textin, int *words)  {
    char ** pruned = NULL;
    char *iter = textin;
    const char * delim = "!,.'; \n"; /* can add other symbols to be cleared, here */
    while ((iter = strtok(iter, delim))) {
        pruned = realloc(pruned, ++(*words)*sizeof (char *)); /* optimism: realloc does not NULL pruned */
        pruned[*words-1] = iter;
        iter = NULL;
    }
    return pruned;
}

char * gettext(char *fname) {
    FILE *infile;
    char *textin = calloc(SIZE, sizeof (char));
    if ((infile=fopen(fname,"rt"))==NULL) exit(1);
    printf("%d bytes read\n", (int) fread(textin, 1, SIZE, infile));
    /* could use fseek/ftell to find size of infile, here we use just a constant */
    printf("%s\n", textin);
    fclose(infile);
    return textin;
}

/* write characters per word in reverse order */
void writetext(char **pruned, int words, char *fname) {
     FILE *outfile;
     int i,j;
     outfile = fopen(fname,"wt");
     for (i=0;i<words;i++) {
            for (j=strlen(pruned[i])-1; j>=0; j--) {
                fprintf(outfile, "%c", pruned[i][j]);
                printf("%c", pruned[i][j]); /* not required */
            }
            fprintf(outfile,"\n");
            printf("\n");/* not required */
    }
    fclose(outfile);
    return;
}
